import java.util.LinkedList;

public class Carreira {

    /* Esta classe Carreira faz a distribuição dos vestbulandos da carreira de Computação
     * entre as listas de chamada dos cursos de Ciência da Computação e Sistemas de Infor-
     * mação.
     */
    
    private static LinkedList<Candidato> listaSI = new LinkedList<Candidato>();
    private static LinkedList<Candidato> listaCC = new LinkedList<Candidato>();

    public static void distribui(LinkedList<Candidato> listaGeral) 
            
    /* Este método realiza a distribuição dos vestibulandos em cada uma das listas. Recebe
     * uma LinkedList de objetos Candidato (as especificações da Classe Candidato você pode
     * ver no arquivo Candidato.java). Apenas esclarecendo que usamos os seguintes valores:
     * 0 (zero) significa que o candidato tem como primeira opção o curso de Ciência da Com-
     * putação e 1 (um) significa que o candidato tem como primeira opção o curso de Siste-
     * mas de Informação. Para este programa, a LinkedList listaGeral pode ter o tamanho que
     * você desejar, porém, em uma situação real, seu tamanho é igual a 240, uma vez que a 
     * quantidade de vagas disponível para SI são 180 e parac CC, 60, o que resulta em 240
     * vagas.
     */ 
    
    {
        for (int i = 0; i < listaGeral.size(); i++) { // Distribui do primeiro até o 240° colocado
            Candidato atual = listaGeral.get(i);
            if (atual.getPrimeiraOpcao() == 0) { // Primeira opção é Ciência da Computação
                if (listaCC.size() < 60) { // Se a lista de CC ainda não estiver cheia
                    listaCC.add(atual); // Adiciona na lista de chamada de CC
                } else if (listaSI.size() < 180) { // Se a lista de CC está cheia e a de SI ainda não
                    listaSI.add(atual); // Adiciona na lista de chamada de SI
                }
            } else if (atual.getPrimeiraOpcao() == 1) { // Primeira opção é Sistemas de Informação
                if (listaSI.size() < 180) { // Se a lista de SI não está cheia
                    listaSI.add(atual); // Adiciona na lista de chamada de SI
                } else if (listaCC.size() < 60) { // Se a lista de SI está cheia e a de CC ainda não
                    listaCC.add(atual); // Adiciona da lista de chamada de CC
                }
            }
        } // fim do for
    } // fim do método
    
    public static void imprimeListasdeChamada(LinkedList<Candidato> listaCC, LinkedList<Candidato> listaSI){
        System.out.println("*** Lista de Chamada de Ciência da Computação ***");
        for (int i = 0; i < listaCC.size(); i++){
            System.out.println(listaCC.get(i).getNome());
        }
        System.out.printf("\n\n\n");
        System.out.println("*** Lista de Chamada de Sistemas de Informação ***");
        for (int i = 0; i < listaSI.size(); i++){
            System.out.println(listaSI.get(i).getNome());
        } 
    } // fim do método
    
    public static LinkedList getListaCC (){
        return listaCC;
    }
    
    public static LinkedList getListaSI (){
        return listaSI;
    }
    
} // fim da classe
